"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withItem = exports.useItem = void 0;
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var scroll_into_view_if_needed_1 = __importDefault(require("scroll-into-view-if-needed"));
var Context_1 = require("../core/Context");
var utils_1 = require("../utils");
var propTypes_1 = require("../propTypes");
var propTypes = {
    option: propTypes_1.optionType.isRequired,
    position: prop_types_1.default.number,
};
function useItem(_a) {
    var label = _a.label, onClick = _a.onClick, option = _a.option, position = _a.position;
    var _b = Context_1.useTypeaheadContext(), activeIndex = _b.activeIndex, id = _b.id, isOnlyResult = _b.isOnlyResult, onActiveItemChange = _b.onActiveItemChange, onInitialItemChange = _b.onInitialItemChange, onMenuItemClick = _b.onMenuItemClick, setItem = _b.setItem;
    var itemRef = react_1.useRef(null);
    react_1.useEffect(function () {
        if (position === 0) {
            onInitialItemChange(option);
        }
    });
    react_1.useEffect(function () {
        if (position === activeIndex) {
            onActiveItemChange(option);
            // Automatically scroll the menu as the user keys through it.
            var node = itemRef.current;
            node &&
                scroll_into_view_if_needed_1.default(node, {
                    block: 'nearest',
                    boundary: node === null || node === void 0 ? void 0 : node.parentNode,
                    inline: 'nearest',
                    scrollMode: 'if-needed',
                });
        }
    });
    var handleClick = react_1.useCallback(function (e) {
        onMenuItemClick(option, e);
        onClick && onClick(e);
    }, [onClick, onMenuItemClick, option]);
    var active = isOnlyResult || activeIndex === position;
    // Update the item's position in the item stack.
    setItem(option, position);
    return {
        active: active,
        'aria-label': label,
        'aria-selected': active,
        id: utils_1.getMenuItemId(id, position),
        onClick: handleClick,
        onMouseDown: utils_1.preventInputBlur,
        ref: itemRef,
        role: 'option',
    };
}
exports.useItem = useItem;
/* istanbul ignore next */
function withItem(Component) {
    var WrappedMenuItem = function (props) { return (react_1.default.createElement(Component, __assign({}, props, useItem(props)))); };
    WrappedMenuItem.displayName = "withItem(" + utils_1.getDisplayName(Component) + ")";
    WrappedMenuItem.propTypes = propTypes;
    return WrappedMenuItem;
}
exports.withItem = withItem;
