"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withToken = exports.useToken = void 0;
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_overlays_1 = require("react-overlays");
var utils_1 = require("../utils");
var propTypes_1 = require("../propTypes");
var propTypes = {
    onBlur: prop_types_1.default.func,
    onClick: prop_types_1.default.func,
    onFocus: prop_types_1.default.func,
    onRemove: prop_types_1.default.func,
    option: propTypes_1.optionType.isRequired,
};
function useToken(_a) {
    var onBlur = _a.onBlur, onClick = _a.onClick, onFocus = _a.onFocus, onRemove = _a.onRemove, option = _a.option, props = __rest(_a, ["onBlur", "onClick", "onFocus", "onRemove", "option"]);
    var _b = react_1.useState(false), active = _b[0], setActive = _b[1];
    var _c = react_1.useState(null), rootElement = _c[0], attachRef = _c[1];
    var handleBlur = function (e) {
        e.stopPropagation();
        setActive(false);
        onBlur && onBlur(e);
    };
    var handleClick = function (e) {
        e.stopPropagation();
        setActive(true);
        onClick && onClick(e);
    };
    var handleFocus = function (e) {
        e.stopPropagation();
        setActive(true);
        onFocus && onFocus(e);
    };
    var handleRemove = function () {
        onRemove && onRemove(option);
    };
    var handleKeyDown = function (e) {
        switch (e.key) {
            case 'Backspace':
                if (active) {
                    // Prevent backspace keypress from triggering the browser "back"
                    // action.
                    e.preventDefault();
                    handleRemove();
                }
                break;
            default:
                break;
        }
    };
    react_overlays_1.useRootClose(rootElement, handleBlur, __assign(__assign({}, props), { disabled: !active }));
    return {
        active: active,
        onBlur: handleBlur,
        onClick: handleClick,
        onFocus: handleFocus,
        onKeyDown: handleKeyDown,
        onRemove: utils_1.isFunction(onRemove) ? handleRemove : undefined,
        ref: attachRef,
    };
}
exports.useToken = useToken;
/* istanbul ignore next */
function withToken(Component) {
    var displayName = "withToken(" + utils_1.getDisplayName(Component) + ")";
    var WrappedToken = function (props) { return (react_1.default.createElement(Component, __assign({}, props, useToken(props)))); };
    WrappedToken.displayName = displayName;
    WrappedToken.propTypes = propTypes;
    return WrappedToken;
}
exports.withToken = withToken;
