"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var utils_1 = require("../utils");
var propTypes_1 = require("../propTypes");
var propTypes = {
    label: prop_types_1.default.string,
    onClick: prop_types_1.default.func,
    onKeyDown: prop_types_1.default.func,
    size: propTypes_1.sizeType,
};
var defaultProps = {
    label: 'Clear',
    onClick: utils_1.noop,
    onKeyDown: utils_1.noop,
};
/**
 * ClearButton
 *
 * http://getbootstrap.com/css/#helper-classes-close
 */
var ClearButton = function (_a) {
    var className = _a.className, label = _a.label, onClick = _a.onClick, onKeyDown = _a.onKeyDown, size = _a.size, props = __rest(_a, ["className", "label", "onClick", "onKeyDown", "size"]);
    return (react_1.default.createElement("button", __assign({}, props, { "aria-label": label, className: classnames_1.default('close', 'rbt-close', {
            'rbt-close-lg': utils_1.isSizeLarge(size),
        }, className), onClick: function (e) {
            e.stopPropagation();
            onClick(e);
        }, onKeyDown: function (e) {
            // Prevent browser from navigating back.
            if (e.key === 'Backspace') {
                e.preventDefault();
            }
            onKeyDown(e);
        }, type: "button" }),
        react_1.default.createElement("span", { "aria-hidden": "true" }, "\u00D7"),
        react_1.default.createElement("span", { className: "sr-only visually-hidden" }, label)));
};
ClearButton.propTypes = propTypes;
ClearButton.defaultProps = defaultProps;
exports.default = ClearButton;
