import PropTypes from 'prop-types';
export interface HighlighterProps {
    children: string;
    highlightClassName: string;
    search: string;
}
/**
 * Stripped-down version of https://github.com/helior/react-highlighter
 *
 * Results are already filtered by the time the component is used internally so
 * we can safely ignore case and diacritical marks for the purposes of matching.
 */
declare const Highlighter: {
    ({ children, highlightClassName, search, }: HighlighterProps): JSX.Element;
    propTypes: {
        children: PropTypes.Validator<string>;
        highlightClassName: PropTypes.Requireable<string>;
        search: PropTypes.Validator<string>;
    };
    defaultProps: {
        highlightClassName: string;
    };
};
export default Highlighter;
