import PropTypes from 'prop-types';
import { HTMLProps, ReactNode, Ref } from 'react';
export interface MenuProps extends HTMLProps<HTMLDivElement> {
    emptyLabel?: ReactNode;
    innerRef: Ref<HTMLDivElement>;
    inputHeight: number;
    scheduleUpdate: () => void;
    maxHeight?: string;
    text: string;
}
/**
 * Menu component that handles empty state when passed a set of results.
 */
declare const Menu: {
    ({ children, className, emptyLabel, innerRef, inputHeight, maxHeight, scheduleUpdate, style, text, ...props }: MenuProps): JSX.Element;
    propTypes: {
        'aria-label': PropTypes.Requireable<string>;
        /**
         * Message to display in the menu if there are no valid results.
         */
        emptyLabel: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * Needed for accessibility.
         */
        id: (props: import("../types").TypeaheadProps, propName: keyof import("../types").TypeaheadProps, componentName: string) => void;
        /**
         * Maximum height of the dropdown menu.
         */
        maxHeight: PropTypes.Requireable<string>;
    };
    defaultProps: {
        'aria-label': string;
    };
    Divider: () => JSX.Element;
    Header: (props: HTMLProps<HTMLDivElement>) => JSX.Element;
};
export default Menu;
