"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var MenuItem_1 = require("./MenuItem");
var utils_1 = require("../utils");
var propTypes_1 = require("../propTypes");
var MenuDivider = function () { return react_1.default.createElement("div", { className: "dropdown-divider", role: "separator" }); };
var MenuHeader = function (props) { return (
// eslint-disable-next-line jsx-a11y/role-has-required-aria-props
react_1.default.createElement("div", __assign({}, props, { className: "dropdown-header", role: "heading" }))); };
var propTypes = {
    'aria-label': prop_types_1.default.string,
    /**
     * Message to display in the menu if there are no valid results.
     */
    emptyLabel: prop_types_1.default.node,
    /**
     * Needed for accessibility.
     */
    id: propTypes_1.checkPropType(prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string]), propTypes_1.isRequiredForA11y),
    /**
     * Maximum height of the dropdown menu.
     */
    maxHeight: prop_types_1.default.string,
};
var defaultProps = {
    'aria-label': 'menu-options',
};
/**
 * Menu component that handles empty state when passed a set of results.
 */
var Menu = function (_a) {
    var children = _a.children, className = _a.className, _b = _a.emptyLabel, emptyLabel = _b === void 0 ? 'No matches found.' : _b, innerRef = _a.innerRef, inputHeight = _a.inputHeight, _c = _a.maxHeight, maxHeight = _c === void 0 ? '300px' : _c, scheduleUpdate = _a.scheduleUpdate, style = _a.style, text = _a.text, props = __rest(_a, ["children", "className", "emptyLabel", "innerRef", "inputHeight", "maxHeight", "scheduleUpdate", "style", "text"]);
    var isInitialMount = react_1.useRef(true);
    react_1.useEffect(function () {
        if (isInitialMount.current) {
            isInitialMount.current = false;
            return;
        }
        scheduleUpdate && scheduleUpdate();
    }, [inputHeight, scheduleUpdate]);
    var contents = react_1.Children.count(children) === 0 ? (react_1.default.createElement(MenuItem_1.BaseMenuItem, { disabled: true, role: "option" }, emptyLabel)) : (children);
    return (
    /* eslint-disable jsx-a11y/interactive-supports-focus */
    react_1.default.createElement("div", __assign({}, props, { className: classnames_1.default('rbt-menu', 'dropdown-menu', 'show', className), key: 
        // Force a re-render if the text changes to ensure that menu
        // positioning updates correctly.
        text, onMouseDown: 
        // Prevent input from blurring when clicking on the menu scrollbar.
        utils_1.preventInputBlur, ref: innerRef, role: "listbox", style: __assign(__assign({}, style), { display: 'block', maxHeight: maxHeight, overflow: 'auto' }) }), contents)
    /* eslint-enable jsx-a11y/interactive-supports-focus */
    );
};
Menu.propTypes = propTypes;
Menu.defaultProps = defaultProps;
Menu.Divider = MenuDivider;
Menu.Header = MenuHeader;
exports.default = Menu;
