"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var ClearButton_1 = __importDefault(require("./ClearButton"));
var token_1 = require("../behaviors/token");
var utils_1 = require("../utils");
var InteractiveToken = react_1.forwardRef(function (_a, ref) {
    var active = _a.active, children = _a.children, className = _a.className, onRemove = _a.onRemove, tabIndex = _a.tabIndex, props = __rest(_a, ["active", "children", "className", "onRemove", "tabIndex"]);
    return (react_1.default.createElement("div", __assign({}, props, { className: classnames_1.default('rbt-token', 'rbt-token-removeable', {
            'rbt-token-active': !!active,
        }, className), ref: ref, tabIndex: tabIndex || 0 }),
        children,
        react_1.default.createElement(ClearButton_1.default, { className: "rbt-token-remove-button", label: "Remove", onClick: onRemove, tabIndex: -1 })));
});
var StaticToken = function (_a) {
    var children = _a.children, className = _a.className, disabled = _a.disabled, href = _a.href;
    var classnames = classnames_1.default('rbt-token', {
        'rbt-token-disabled': disabled,
    }, className);
    if (href && !disabled) {
        return (react_1.default.createElement("a", { className: classnames, href: href }, children));
    }
    return react_1.default.createElement("div", { className: classnames }, children);
};
/**
 * Token
 *
 * Individual token component, generally displayed within the TokenizerInput
 * component, but can also be rendered on its own.
 */
var Token = function (_a) {
    var readOnly = _a.readOnly, props = __rest(_a, ["readOnly"]);
    var _b = token_1.useToken(props), ref = _b.ref, tokenProps = __rest(_b, ["ref"]);
    return !props.disabled && !readOnly && utils_1.isFunction(tokenProps.onRemove) ? (react_1.default.createElement(InteractiveToken, __assign({}, props, tokenProps, { ref: ref }))) : (react_1.default.createElement(StaticToken, __assign({}, props)));
};
exports.default = Token;
