"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_overlays_1 = require("react-overlays");
var Typeahead_1 = __importDefault(require("../core/Typeahead"));
var ClearButton_1 = __importDefault(require("./ClearButton"));
var Loader_1 = __importDefault(require("./Loader"));
var Overlay_1 = __importDefault(require("./Overlay"));
var Token_1 = __importDefault(require("./Token"));
var TypeaheadInputMulti_1 = __importDefault(require("./TypeaheadInputMulti"));
var TypeaheadInputSingle_1 = __importDefault(require("./TypeaheadInputSingle"));
var TypeaheadMenu_1 = __importDefault(require("./TypeaheadMenu"));
var utils_1 = require("../utils");
var propTypes_1 = require("../propTypes");
var propTypes = {
    /**
     * Displays a button to clear the input when there are selections.
     */
    clearButton: prop_types_1.default.bool,
    /**
     * Props to be applied directly to the input. `onBlur`, `onChange`,
     * `onFocus`, and `onKeyDown` are ignored.
     */
    inputProps: propTypes_1.checkPropType(prop_types_1.default.object, propTypes_1.inputPropsType),
    /**
     * Bootstrap 4 only. Adds the `is-invalid` classname to the `form-control`.
     */
    isInvalid: prop_types_1.default.bool,
    /**
     * Indicate whether an asynchronous data fetch is happening.
     */
    isLoading: prop_types_1.default.bool,
    /**
     * Bootstrap 4 only. Adds the `is-valid` classname to the `form-control`.
     */
    isValid: prop_types_1.default.bool,
    /**
     * Callback for custom input rendering.
     */
    renderInput: prop_types_1.default.func,
    /**
     * Callback for custom menu rendering.
     */
    renderMenu: prop_types_1.default.func,
    /**
     * Callback for custom menu rendering.
     */
    renderToken: prop_types_1.default.func,
    /**
     * Specifies the size of the input.
     */
    size: propTypes_1.sizeType,
};
var defaultProps = {
    isLoading: false,
};
var defaultRenderMenu = function (results, menuProps, props) { return (react_1.default.createElement(TypeaheadMenu_1.default, __assign({}, menuProps, { labelKey: props.labelKey, options: results, text: props.text }))); };
var defaultRenderToken = function (option, props, idx) { return (react_1.default.createElement(Token_1.default, { disabled: props.disabled, key: idx, onRemove: props.onRemove, option: option, tabIndex: props.tabIndex }, utils_1.getOptionLabel(option, props.labelKey))); };
var overlayPropKeys = [
    'align',
    'dropup',
    'flip',
    'positionFixed',
];
function getOverlayProps(props) {
    return utils_1.pick(props, overlayPropKeys);
}
var RootClose = function (_a) {
    var children = _a.children, onRootClose = _a.onRootClose, props = __rest(_a, ["children", "onRootClose"]);
    var _b = react_1.useState(null), rootElement = _b[0], attachRef = _b[1];
    react_overlays_1.useRootClose(rootElement, onRootClose, props);
    return children(attachRef);
};
var TypeaheadComponent = /** @class */ (function (_super) {
    __extends(TypeaheadComponent, _super);
    function TypeaheadComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._referenceElement = null;
        _this.referenceElementRef = function (referenceElement) {
            _this._referenceElement = referenceElement;
        };
        _this._renderInput = function (inputProps, props) {
            var _a = _this.props, isInvalid = _a.isInvalid, isValid = _a.isValid, multiple = _a.multiple, renderInput = _a.renderInput, renderToken = _a.renderToken, size = _a.size;
            if (utils_1.isFunction(renderInput)) {
                return renderInput(inputProps, props);
            }
            var commonProps = __assign(__assign({}, inputProps), { isInvalid: isInvalid, isValid: isValid, size: size });
            if (!multiple) {
                return react_1.default.createElement(TypeaheadInputSingle_1.default, __assign({}, commonProps));
            }
            var labelKey = props.labelKey, onRemove = props.onRemove, selected = props.selected;
            return (react_1.default.createElement(TypeaheadInputMulti_1.default, __assign({}, commonProps, { selected: selected }), selected.map(function (option, idx) {
                return (renderToken || defaultRenderToken)(option, __assign(__assign({}, commonProps), { labelKey: labelKey, onRemove: onRemove }), idx);
            })));
        };
        _this._renderMenu = function (results, menuProps, props) {
            var _a = _this.props, emptyLabel = _a.emptyLabel, id = _a.id, maxHeight = _a.maxHeight, newSelectionPrefix = _a.newSelectionPrefix, paginationText = _a.paginationText, renderMenu = _a.renderMenu, renderMenuItemChildren = _a.renderMenuItemChildren;
            return (renderMenu || defaultRenderMenu)(results, __assign(__assign({}, menuProps), { emptyLabel: emptyLabel, id: id, maxHeight: maxHeight, newSelectionPrefix: newSelectionPrefix, paginationText: paginationText, renderMenuItemChildren: renderMenuItemChildren }), props);
        };
        _this._renderAux = function (_a) {
            var onClear = _a.onClear, selected = _a.selected;
            var _b = _this.props, clearButton = _b.clearButton, disabled = _b.disabled, isLoading = _b.isLoading, size = _b.size;
            var content;
            if (isLoading) {
                content = react_1.default.createElement(Loader_1.default, null);
            }
            else if (clearButton && !disabled && selected.length) {
                content = (react_1.default.createElement(ClearButton_1.default, { onClick: onClear, onMouseDown: utils_1.preventInputBlur, size: size }));
            }
            return content ? (react_1.default.createElement("div", { className: classnames_1.default('rbt-aux', { 'rbt-aux-lg': utils_1.isSizeLarge(size) }) }, content)) : null;
        };
        return _this;
    }
    TypeaheadComponent.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, className = _a.className, instanceRef = _a.instanceRef, open = _a.open, options = _a.options, style = _a.style;
        return (react_1.default.createElement(Typeahead_1.default, __assign({}, this.props, { options: options, ref: instanceRef }), function (props) {
            var hideMenu = props.hideMenu, isMenuShown = props.isMenuShown, results = props.results;
            var auxContent = _this._renderAux(props);
            return (react_1.default.createElement(RootClose, { disabled: open || !isMenuShown, onRootClose: hideMenu }, function (ref) { return (react_1.default.createElement("div", { className: classnames_1.default('rbt', { 'has-aux': !!auxContent }, className), ref: ref, style: __assign(__assign({}, style), { outline: 'none', position: 'relative' }), tabIndex: -1 },
                _this._renderInput(__assign(__assign({}, props.getInputProps(_this.props.inputProps)), { referenceElementRef: _this.referenceElementRef }), props),
                react_1.default.createElement(Overlay_1.default, __assign({}, getOverlayProps(_this.props), { isMenuShown: isMenuShown, referenceElement: _this._referenceElement }), function (menuProps) {
                    return _this._renderMenu(results, menuProps, props);
                }),
                auxContent,
                utils_1.isFunction(children) ? children(props) : children)); }));
        }));
    };
    TypeaheadComponent.propTypes = propTypes;
    TypeaheadComponent.defaultProps = defaultProps;
    return TypeaheadComponent;
}(react_1.default.Component));
exports.default = react_1.forwardRef(function (props, ref) { return (react_1.default.createElement(TypeaheadComponent, __assign({}, props, { instanceRef: ref }))); });
