"use strict";
/* eslint-disable jsx-a11y/no-static-element-interactions */
/* eslint-disable jsx-a11y/click-events-have-key-events */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var Hint_1 = __importDefault(require("./Hint"));
var Input_1 = __importDefault(require("./Input"));
var utils_1 = require("../utils");
var classNames_1 = __importDefault(require("../behaviors/classNames"));
var TypeaheadInputMulti = /** @class */ (function (_super) {
    __extends(TypeaheadInputMulti, _super);
    function TypeaheadInputMulti() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.wrapperRef = react_1.default.createRef();
        _this._input = null;
        _this.getInputRef = function (input) {
            _this._input = input;
            _this.props.inputRef(input);
        };
        _this._handleClick = function (e) {
            // Prevent clicks on the input from bubbling up to the container,
            // which then re-focuses the input.
            e.stopPropagation();
            _this.props.onClick(e);
        };
        /**
         * Forward click or focus events on the container element to the input.
         */
        _this._handleContainerClickOrFocus = function (e) {
            // Don't focus the input if it's disabled.
            if (_this.props.disabled) {
                e.currentTarget.blur();
                return;
            }
            // Move cursor to the end if the user clicks outside the actual input.
            var inputNode = _this._input;
            if (!inputNode) {
                return;
            }
            if (utils_1.isSelectable(inputNode)) {
                inputNode.selectionStart = inputNode.value.length;
            }
            inputNode.focus();
        };
        _this._handleKeyDown = function (e) {
            var _a = _this.props, onKeyDown = _a.onKeyDown, selected = _a.selected, value = _a.value;
            switch (e.key) {
                case 'Backspace':
                    if (e.currentTarget === _this._input && selected.length && !value) {
                        // Prevent browser from going back.
                        e.preventDefault();
                        // If the input is selected and there is no text, focus the last
                        // token when the user hits backspace.
                        if (_this.wrapperRef.current) {
                            var children = _this.wrapperRef.current.children;
                            var lastToken = children[children.length - 2];
                            lastToken && lastToken.focus();
                        }
                    }
                    break;
                default:
                    break;
            }
            onKeyDown(e);
        };
        return _this;
    }
    TypeaheadInputMulti.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className, inputClassName = _a.inputClassName, inputRef = _a.inputRef, placeholder = _a.placeholder, referenceElementRef = _a.referenceElementRef, selected = _a.selected, shouldSelectHint = _a.shouldSelectHint, props = __rest(_a, ["children", "className", "inputClassName", "inputRef", "placeholder", "referenceElementRef", "selected", "shouldSelectHint"]);
        return (react_1.default.createElement("div", { className: classnames_1.default('rbt-input-multi', className), onClick: this._handleContainerClickOrFocus, onFocus: this._handleContainerClickOrFocus, ref: referenceElementRef, tabIndex: -1 },
            react_1.default.createElement("div", { className: "rbt-input-wrapper", ref: this.wrapperRef },
                children,
                react_1.default.createElement(Hint_1.default, { shouldSelect: shouldSelectHint },
                    react_1.default.createElement(Input_1.default, __assign({}, props, { className: inputClassName, onClick: this._handleClick, onKeyDown: this._handleKeyDown, placeholder: selected.length ? '' : placeholder, ref: this.getInputRef, style: {
                            backgroundColor: 'transparent',
                            border: 0,
                            boxShadow: 'none',
                            cursor: 'inherit',
                            outline: 'none',
                            padding: 0,
                            width: '100%',
                            zIndex: 1,
                        } }))))));
    };
    return TypeaheadInputMulti;
}(react_1.default.Component));
exports.default = classNames_1.default(TypeaheadInputMulti);
