import PropTypes from 'prop-types';
import { ReactNode } from 'react';
import { MenuProps } from './Menu';
import { LabelKey, Option } from '../types';
export declare type RenderMenuItemChildren = (option: Option, menuProps: TypeaheadMenuProps, idx: number) => JSX.Element;
export interface TypeaheadMenuProps extends Omit<MenuProps, 'ref'> {
    labelKey: LabelKey;
    newSelectionPrefix: ReactNode;
    options: Option[];
    paginationText: ReactNode;
    renderMenuItemChildren: RenderMenuItemChildren;
    text: string;
}
declare const TypeaheadMenu: {
    (props: TypeaheadMenuProps): JSX.Element;
    propTypes: {
        /**
         * Provides the ability to specify a prefix before the user-entered text to
         * indicate that the selection will be new. No-op unless `allowNew={true}`.
         */
        newSelectionPrefix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * Prompt displayed when large data sets are paginated.
         */
        paginationText: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * Provides a hook for customized rendering of menu item contents.
         */
        renderMenuItemChildren: PropTypes.Requireable<(...args: any[]) => any>;
    };
    defaultProps: {
        newSelectionPrefix: string;
        paginationText: string;
        renderMenuItemChildren: (option: Option, props: TypeaheadMenuProps) => JSX.Element;
    };
};
export default TypeaheadMenu;
