"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toggleMenu = exports.hideMenu = exports.clickOrFocusInput = exports.clearTypeahead = exports.getInitialState = void 0;
var fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var TypeaheadManager_1 = __importDefault(require("./TypeaheadManager"));
var propTypes_1 = require("../propTypes");
var utils_1 = require("../utils");
var constants_1 = require("../constants");
var propTypes = {
    /**
     * Allows the creation of new selections on the fly. Note that any new items
     * will be added to the list of selections, but not the list of original
     * options unless handled as such by `Typeahead`'s parent.
     *
     * If a function is specified, it will be used to determine whether a custom
     * option should be included. The return value should be true or false.
     */
    allowNew: prop_types_1.default.oneOfType([prop_types_1.default.bool, prop_types_1.default.func]),
    /**
     * Autofocus the input when the component initially mounts.
     */
    autoFocus: prop_types_1.default.bool,
    /**
     * Whether or not filtering should be case-sensitive.
     */
    caseSensitive: propTypes_1.checkPropType(prop_types_1.default.bool, propTypes_1.caseSensitiveType),
    /**
     * The initial value displayed in the text input.
     */
    defaultInputValue: propTypes_1.checkPropType(prop_types_1.default.string, propTypes_1.defaultInputValueType),
    /**
     * Whether or not the menu is displayed upon initial render.
     */
    defaultOpen: prop_types_1.default.bool,
    /**
     * Specify any pre-selected options. Use only if you want the component to
     * be uncontrolled.
     */
    defaultSelected: propTypes_1.checkPropType(prop_types_1.default.arrayOf(propTypes_1.optionType), propTypes_1.defaultSelectedType),
    /**
     * Either an array of fields in `option` to search, or a custom filtering
     * callback.
     */
    filterBy: prop_types_1.default.oneOfType([
        prop_types_1.default.arrayOf(prop_types_1.default.string.isRequired),
        prop_types_1.default.func,
    ]),
    /**
     * Highlights the menu item if there is only one result and allows selecting
     * that item by hitting enter. Does not work with `allowNew`.
     */
    highlightOnlyResult: propTypes_1.checkPropType(prop_types_1.default.bool, propTypes_1.highlightOnlyResultType),
    /**
     * An html id attribute, required for assistive technologies such as screen
     * readers.
     */
    id: propTypes_1.checkPropType(prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string]), propTypes_1.isRequiredForA11y),
    /**
     * Whether the filter should ignore accents and other diacritical marks.
     */
    ignoreDiacritics: propTypes_1.checkPropType(prop_types_1.default.bool, propTypes_1.ignoreDiacriticsType),
    /**
     * Specify the option key to use for display or a function returning the
     * display string. By default, the selector will use the `label` key.
     */
    labelKey: propTypes_1.checkPropType(prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.func]), propTypes_1.labelKeyType),
    /**
     * Maximum number of results to display by default. Mostly done for
     * performance reasons so as not to render too many DOM nodes in the case of
     * large data sets.
     */
    maxResults: prop_types_1.default.number,
    /**
     * Number of input characters that must be entered before showing results.
     */
    minLength: prop_types_1.default.number,
    /**
     * Whether or not multiple selections are allowed.
     */
    multiple: prop_types_1.default.bool,
    /**
     * Invoked when the input is blurred. Receives an event.
     */
    onBlur: prop_types_1.default.func,
    /**
     * Invoked whenever items are added or removed. Receives an array of the
     * selected options.
     */
    onChange: prop_types_1.default.func,
    /**
     * Invoked when the input is focused. Receives an event.
     */
    onFocus: prop_types_1.default.func,
    /**
     * Invoked when the input value changes. Receives the string value of the
     * input.
     */
    onInputChange: prop_types_1.default.func,
    /**
     * Invoked when a key is pressed. Receives an event.
     */
    onKeyDown: prop_types_1.default.func,
    /**
     * Invoked when menu visibility changes.
     */
    onMenuToggle: prop_types_1.default.func,
    /**
     * Invoked when the pagination menu item is clicked. Receives an event.
     */
    onPaginate: prop_types_1.default.func,
    /**
     * Whether or not the menu should be displayed. `undefined` allows the
     * component to control visibility, while `true` and `false` show and hide
     * the menu, respectively.
     */
    open: prop_types_1.default.bool,
    /**
     * Full set of options, including pre-selected options. Must either be an
     * array of objects (recommended) or strings.
     */
    options: prop_types_1.default.arrayOf(propTypes_1.optionType).isRequired,
    /**
     * Give user the ability to display additional results if the number of
     * results exceeds `maxResults`.
     */
    paginate: prop_types_1.default.bool,
    /**
     * The selected option(s) displayed in the input. Use this prop if you want
     * to control the component via its parent.
     */
    selected: propTypes_1.checkPropType(prop_types_1.default.arrayOf(propTypes_1.optionType), propTypes_1.selectedType),
};
var defaultProps = {
    allowNew: false,
    autoFocus: false,
    caseSensitive: false,
    defaultInputValue: '',
    defaultOpen: false,
    defaultSelected: [],
    filterBy: [],
    highlightOnlyResult: false,
    ignoreDiacritics: true,
    labelKey: constants_1.DEFAULT_LABELKEY,
    maxResults: 100,
    minLength: 0,
    multiple: false,
    onBlur: utils_1.noop,
    onFocus: utils_1.noop,
    onInputChange: utils_1.noop,
    onKeyDown: utils_1.noop,
    onMenuToggle: utils_1.noop,
    onPaginate: utils_1.noop,
    paginate: true,
};
function getInitialState(props) {
    var defaultInputValue = props.defaultInputValue, defaultOpen = props.defaultOpen, defaultSelected = props.defaultSelected, maxResults = props.maxResults, multiple = props.multiple;
    var selected = props.selected
        ? props.selected.slice()
        : defaultSelected.slice();
    var text = defaultInputValue;
    if (!multiple && selected.length) {
        // Set the text if an initial selection is passed in.
        text = utils_1.getOptionLabel(selected[0], props.labelKey);
        if (selected.length > 1) {
            // Limit to 1 selection in single-select mode.
            selected = selected.slice(0, 1);
        }
    }
    return {
        activeIndex: -1,
        activeItem: undefined,
        initialItem: undefined,
        isFocused: false,
        selected: selected,
        showMenu: defaultOpen,
        shownResults: maxResults,
        text: text,
    };
}
exports.getInitialState = getInitialState;
function clearTypeahead(state, props) {
    return __assign(__assign({}, getInitialState(props)), { isFocused: state.isFocused, selected: [], text: '' });
}
exports.clearTypeahead = clearTypeahead;
function clickOrFocusInput(state) {
    return __assign(__assign({}, state), { isFocused: true, showMenu: true });
}
exports.clickOrFocusInput = clickOrFocusInput;
function hideMenu(state, props) {
    var _a = getInitialState(props), activeIndex = _a.activeIndex, activeItem = _a.activeItem, initialItem = _a.initialItem, shownResults = _a.shownResults;
    return __assign(__assign({}, state), { activeIndex: activeIndex, activeItem: activeItem, initialItem: initialItem, showMenu: false, shownResults: shownResults });
}
exports.hideMenu = hideMenu;
function toggleMenu(state, props) {
    return state.showMenu ? hideMenu(state, props) : __assign(__assign({}, state), { showMenu: true });
}
exports.toggleMenu = toggleMenu;
/**
 * Manually trigger the input's change event.
 * https://stackoverflow.com/questions/23892547/what-is-the-best-way-to-trigger-onchange-event-in-react-js/46012210#46012210
 */
function triggerInputChange(input, value) {
    var inputValue = Object.getOwnPropertyDescriptor(window.HTMLInputElement.prototype, 'value');
    inputValue && inputValue.set && inputValue.set.call(input, value);
    var e = new Event('input', { bubbles: true });
    input.dispatchEvent(e);
}
var Typeahead = /** @class */ (function (_super) {
    __extends(Typeahead, _super);
    function Typeahead() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = getInitialState(_this.props);
        _this.inputNode = null;
        _this.isMenuShown = false;
        // Keeps track of actual items displayed in the menu, after sorting,
        // truncating, grouping, etc.
        _this.items = [];
        _this.blur = function () {
            _this.inputNode && _this.inputNode.blur();
            _this.hideMenu();
        };
        _this.clear = function () {
            _this.setState(clearTypeahead);
        };
        _this.focus = function () {
            _this.inputNode && _this.inputNode.focus();
        };
        _this.getInput = function () {
            return _this.inputNode;
        };
        _this.inputRef = function (inputNode) {
            _this.inputNode = inputNode;
        };
        _this.setItem = function (item, position) {
            _this.items[position] = item;
        };
        _this.hideMenu = function () {
            _this.setState(hideMenu);
        };
        _this.toggleMenu = function () {
            _this.setState(toggleMenu);
        };
        _this._handleActiveIndexChange = function (activeIndex) {
            _this.setState(function (state) { return ({
                activeIndex: activeIndex,
                activeItem: activeIndex >= 0 ? state.activeItem : undefined,
            }); });
        };
        _this._handleActiveItemChange = function (activeItem) {
            // Don't update the active item if it hasn't changed.
            if (!fast_deep_equal_1.default(activeItem, _this.state.activeItem)) {
                _this.setState({ activeItem: activeItem });
            }
        };
        _this._handleBlur = function (e) {
            e.persist();
            _this.setState({ isFocused: false }, function () { return _this.props.onBlur(e); });
        };
        _this._handleChange = function (selected) {
            _this.props.onChange && _this.props.onChange(selected);
        };
        _this._handleClear = function () {
            _this.inputNode && triggerInputChange(_this.inputNode, '');
            _this.setState(clearTypeahead, function () {
                // Change handler is automatically triggered for single selections but
                // not multi-selections.
                if (_this.props.multiple) {
                    _this._handleChange([]);
                }
            });
        };
        _this._handleClick = function (e) {
            var _a;
            e.persist();
            var onClick = (_a = _this.props.inputProps) === null || _a === void 0 ? void 0 : _a.onClick;
            _this.setState(clickOrFocusInput, function () { return utils_1.isFunction(onClick) && onClick(e); });
        };
        _this._handleFocus = function (e) {
            e.persist();
            _this.setState(clickOrFocusInput, function () { return _this.props.onFocus(e); });
        };
        _this._handleInitialItemChange = function (initialItem) {
            // Don't update the initial item if it hasn't changed.
            if (!fast_deep_equal_1.default(initialItem, _this.state.initialItem)) {
                _this.setState({ initialItem: initialItem });
            }
        };
        _this._handleInputChange = function (e) {
            e.persist();
            var text = e.currentTarget.value;
            var _a = _this.props, multiple = _a.multiple, onInputChange = _a.onInputChange;
            // Clear selections when the input value changes in single-select mode.
            var shouldClearSelections = _this.state.selected.length && !multiple;
            _this.setState(function (state, props) {
                var _a = getInitialState(props), activeIndex = _a.activeIndex, activeItem = _a.activeItem, shownResults = _a.shownResults;
                return {
                    activeIndex: activeIndex,
                    activeItem: activeItem,
                    selected: shouldClearSelections ? [] : state.selected,
                    showMenu: true,
                    shownResults: shownResults,
                    text: text,
                };
            }, function () {
                onInputChange(text, e);
                shouldClearSelections && _this._handleChange([]);
            });
        };
        _this._handleKeyDown = function (e) {
            var activeItem = _this.state.activeItem;
            // Skip most actions when the menu is hidden.
            if (!_this.isMenuShown) {
                if (e.key === 'ArrowUp' || e.key === 'ArrowDown') {
                    _this.setState({ showMenu: true });
                }
                _this.props.onKeyDown(e);
                return;
            }
            switch (e.key) {
                case 'ArrowUp':
                case 'ArrowDown':
                    // Prevent input cursor from going to the beginning when pressing up.
                    e.preventDefault();
                    _this._handleActiveIndexChange(utils_1.getUpdatedActiveIndex(_this.state.activeIndex, e.key, _this.items));
                    break;
                case 'Enter':
                    // Prevent form submission while menu is open.
                    e.preventDefault();
                    activeItem && _this._handleMenuItemSelect(activeItem, e);
                    break;
                case 'Escape':
                case 'Tab':
                    // ESC simply hides the menu. TAB will blur the input and move focus to
                    // the next item; hide the menu so it doesn't gain focus.
                    _this.hideMenu();
                    break;
                default:
                    break;
            }
            _this.props.onKeyDown(e);
        };
        _this._handleMenuItemSelect = function (option, e) {
            if (utils_1.getOptionProperty(option, 'paginationOption')) {
                _this._handlePaginate(e);
            }
            else {
                _this._handleSelectionAdd(option);
            }
        };
        _this._handlePaginate = function (e) {
            e.persist();
            _this.setState(function (state, props) { return ({
                shownResults: state.shownResults + props.maxResults,
            }); }, function () { return _this.props.onPaginate(e, _this.state.shownResults); });
        };
        _this._handleSelectionAdd = function (option) {
            var _a = _this.props, multiple = _a.multiple, labelKey = _a.labelKey;
            var selected;
            var selection = option;
            var text;
            // Add a unique id to the custom selection. Avoid doing this in `render` so
            // the id doesn't increment every time.
            if (!utils_1.isString(selection) && selection.customOption) {
                selection = __assign(__assign({}, selection), { id: utils_1.uniqueId('new-id-') });
            }
            if (multiple) {
                // If multiple selections are allowed, add the new selection to the
                // existing selections.
                selected = _this.state.selected.concat(selection);
                text = '';
            }
            else {
                // If only a single selection is allowed, replace the existing selection
                // with the new one.
                selected = [selection];
                text = utils_1.getOptionLabel(selection, labelKey);
            }
            _this.setState(function (state, props) { return (__assign(__assign({}, hideMenu(state, props)), { initialItem: selection, selected: selected, text: text })); }, function () { return _this._handleChange(selected); });
        };
        _this._handleSelectionRemove = function (selection) {
            var selected = _this.state.selected.filter(function (option) { return !fast_deep_equal_1.default(option, selection); });
            // Make sure the input stays focused after the item is removed.
            _this.focus();
            _this.setState(function (state, props) { return (__assign(__assign({}, hideMenu(state, props)), { selected: selected })); }, function () { return _this._handleChange(selected); });
        };
        return _this;
    }
    Typeahead.prototype.componentDidMount = function () {
        this.props.autoFocus && this.focus();
    };
    Typeahead.prototype.componentDidUpdate = function (prevProps, prevState) {
        var _a = this.props, labelKey = _a.labelKey, multiple = _a.multiple, selected = _a.selected;
        utils_1.validateSelectedPropChange(selected, prevProps.selected);
        // Sync selections in state with those in props.
        if (selected && !fast_deep_equal_1.default(selected, prevState.selected)) {
            this.setState({ selected: selected });
            if (!multiple) {
                this.setState({
                    text: selected.length ? utils_1.getOptionLabel(selected[0], labelKey) : '',
                });
            }
        }
    };
    Typeahead.prototype.render = function () {
        var _a, _b;
        var _c = this.props, onChange = _c.onChange, props = __rest(_c, ["onChange"]);
        var mergedPropsAndState = __assign(__assign({}, props), this.state);
        var filterBy = mergedPropsAndState.filterBy, labelKey = mergedPropsAndState.labelKey, options = mergedPropsAndState.options, paginate = mergedPropsAndState.paginate, shownResults = mergedPropsAndState.shownResults, text = mergedPropsAndState.text;
        this.isMenuShown = utils_1.isShown(mergedPropsAndState);
        this.items = []; // Reset items on re-render.
        var results = [];
        if (this.isMenuShown) {
            var cb_1 = (utils_1.isFunction(filterBy) ? filterBy : utils_1.defaultFilterBy);
            results = options.filter(function (option) {
                return cb_1(option, mergedPropsAndState);
            });
            // This must come before results are truncated.
            var shouldPaginate = paginate && results.length > shownResults;
            // Truncate results if necessary.
            results = utils_1.getTruncatedOptions(results, shownResults);
            // Add the custom option if necessary.
            if (utils_1.addCustomOption(results, mergedPropsAndState)) {
                results.push((_a = {
                        customOption: true
                    },
                    _a[utils_1.getStringLabelKey(labelKey)] = text,
                    _a));
            }
            // Add the pagination item if necessary.
            if (shouldPaginate) {
                results.push((_b = {},
                    _b[utils_1.getStringLabelKey(labelKey)] = '',
                    _b.paginationOption = true,
                    _b));
            }
        }
        return (react_1.default.createElement(TypeaheadManager_1.default, __assign({}, mergedPropsAndState, { hideMenu: this.hideMenu, inputNode: this.inputNode, inputRef: this.inputRef, isMenuShown: this.isMenuShown, onActiveItemChange: this._handleActiveItemChange, onAdd: this._handleSelectionAdd, onBlur: this._handleBlur, onChange: this._handleInputChange, onClear: this._handleClear, onClick: this._handleClick, onFocus: this._handleFocus, onHide: this.hideMenu, onInitialItemChange: this._handleInitialItemChange, onKeyDown: this._handleKeyDown, onMenuItemClick: this._handleMenuItemSelect, onRemove: this._handleSelectionRemove, results: results, setItem: this.setItem, toggleMenu: this.toggleMenu })));
    };
    Typeahead.propTypes = propTypes;
    Typeahead.defaultProps = defaultProps;
    return Typeahead;
}(react_1.default.Component));
exports.default = Typeahead;
