"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var usePrevious_1 = __importDefault(require("@restart/hooks/usePrevious"));
var Context_1 = require("./Context");
var utils_1 = require("../utils");
var inputPropKeys = [
    'activeIndex',
    'disabled',
    'id',
    'inputRef',
    'isFocused',
    'isMenuShown',
    'multiple',
    'onBlur',
    'onChange',
    'onClick',
    'onFocus',
    'onKeyDown',
    'placeholder',
];
var propKeys = [
    'activeIndex',
    'hideMenu',
    'isMenuShown',
    'labelKey',
    'onClear',
    'onHide',
    'onRemove',
    'results',
    'selected',
    'text',
    'toggleMenu',
];
var contextKeys = [
    'activeIndex',
    'id',
    'initialItem',
    'inputNode',
    'onActiveItemChange',
    'onAdd',
    'onInitialItemChange',
    'onMenuItemClick',
    'setItem',
];
var TypeaheadManager = function (props) {
    var allowNew = props.allowNew, children = props.children, initialItem = props.initialItem, isMenuShown = props.isMenuShown, onAdd = props.onAdd, onInitialItemChange = props.onInitialItemChange, onKeyDown = props.onKeyDown, onMenuToggle = props.onMenuToggle, results = props.results;
    var prevProps = usePrevious_1.default(props);
    react_1.useEffect(function () {
        // Clear the initial item when there are no results.
        if (!(allowNew || results.length)) {
            onInitialItemChange();
        }
    });
    react_1.useEffect(function () {
        if (prevProps && prevProps.isMenuShown !== isMenuShown) {
            onMenuToggle(isMenuShown);
        }
    });
    var handleKeyDown = function (e) {
        switch (e.key) {
            case 'Enter':
                if (initialItem && utils_1.getIsOnlyResult(props)) {
                    onAdd(initialItem);
                }
                break;
            default:
                break;
        }
        onKeyDown(e);
    };
    var childProps = __assign(__assign({}, utils_1.pick(props, propKeys)), { getInputProps: utils_1.getInputProps(__assign(__assign({}, utils_1.pick(props, inputPropKeys)), { onKeyDown: handleKeyDown, value: utils_1.getInputText(props) })) });
    var contextValue = __assign(__assign({}, utils_1.pick(props, contextKeys)), { hintText: utils_1.getHintText(props), isOnlyResult: utils_1.getIsOnlyResult(props) });
    return (react_1.default.createElement(Context_1.TypeaheadContext.Provider, { value: contextValue }, children(childProps)));
};
exports.default = TypeaheadManager;
