"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var getOptionLabel_1 = __importDefault(require("./getOptionLabel"));
var nodash_1 = require("./nodash");
function addCustomOption(results, props) {
    var allowNew = props.allowNew, labelKey = props.labelKey, text = props.text;
    if (!allowNew || !text.trim()) {
        return false;
    }
    // If the consumer has provided a callback, use that to determine whether or
    // not to add the custom option.
    if (nodash_1.isFunction(allowNew)) {
        return allowNew(results, props);
    }
    // By default, don't add the custom option if there is an exact text match
    // with an existing option.
    return !results.some(function (o) { return getOptionLabel_1.default(o, labelKey) === text; });
}
exports.default = addCustomOption;
