"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var getMatchBounds_1 = __importDefault(require("./getMatchBounds"));
var getOptionLabel_1 = __importDefault(require("./getOptionLabel"));
var hasOwnProperty_1 = __importDefault(require("./hasOwnProperty"));
var nodash_1 = require("./nodash");
function getHintText(_a) {
    var activeIndex = _a.activeIndex, initialItem = _a.initialItem, isFocused = _a.isFocused, isMenuShown = _a.isMenuShown, labelKey = _a.labelKey, multiple = _a.multiple, selected = _a.selected, text = _a.text;
    // Don't display a hint under the following conditions:
    if (
    // No text entered.
    !text ||
        // The input is not focused.
        !isFocused ||
        // The menu is hidden.
        !isMenuShown ||
        // No item in the menu.
        !initialItem ||
        // The initial item is a custom option.
        (!nodash_1.isString(initialItem) && hasOwnProperty_1.default(initialItem, 'customOption')) ||
        // One of the menu items is active.
        activeIndex > -1 ||
        // There's already a selection in single-select mode.
        (!!selected.length && !multiple)) {
        return '';
    }
    var initialItemStr = getOptionLabel_1.default(initialItem, labelKey);
    var bounds = getMatchBounds_1.default(initialItemStr.toLowerCase(), text.toLowerCase());
    if (!(bounds && bounds.start === 0)) {
        return '';
    }
    // Text matching is case- and accent-insensitive, so to display the hint
    // correctly, splice the input string with the hint string.
    return text + initialItemStr.slice(bounds.end, initialItemStr.length);
}
exports.default = getHintText;
