"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var getMenuItemId_1 = __importDefault(require("./getMenuItemId"));
var hasOwnProperty_1 = __importDefault(require("./hasOwnProperty"));
var getInputProps = function (_a) {
    var activeIndex = _a.activeIndex, id = _a.id, isFocused = _a.isFocused, isMenuShown = _a.isMenuShown, multiple = _a.multiple, onClick = _a.onClick, onFocus = _a.onFocus, placeholder = _a.placeholder, rest = __rest(_a, ["activeIndex", "id", "isFocused", "isMenuShown", "multiple", "onClick", "onFocus", "placeholder"]);
    return function (inputProps) {
        var _a;
        if (inputProps === void 0) { inputProps = {}; }
        var className = hasOwnProperty_1.default(inputProps, 'className')
            ? inputProps.className
            : undefined;
        var props = __assign(__assign(__assign({ 
            // These props can be overridden by values in `inputProps`.
            autoComplete: 'off', placeholder: placeholder, type: 'text' }, inputProps), rest), { 'aria-activedescendant': activeIndex >= 0 ? getMenuItemId_1.default(id, activeIndex) : undefined, 'aria-autocomplete': 'both', 'aria-expanded': isMenuShown, 'aria-haspopup': 'listbox', 'aria-owns': isMenuShown ? id : undefined, className: classnames_1.default((_a = {},
                _a[(className || '')] = !multiple,
                _a.focus = isFocused,
                _a)), onClick: onClick, onFocus: onFocus, 
            // Comboboxes are single-select by definition:
            // https://www.w3.org/TR/wai-aria-practices-1.1/#combobox
            role: 'combobox' });
        if (!multiple) {
            return props;
        }
        return __assign(__assign({}, props), { 'aria-autocomplete': 'list', 'aria-expanded': undefined, inputClassName: className, role: undefined });
    };
};
exports.default = getInputProps;
