"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipDisabledOptions = exports.isDisabledOption = void 0;
var nodash_1 = require("./nodash");
var hasOwnProperty_1 = __importDefault(require("./hasOwnProperty"));
function isDisabledOption(index, items) {
    var option = items[index];
    return !!option && !nodash_1.isString(option) && hasOwnProperty_1.default(option, 'disabled');
}
exports.isDisabledOption = isDisabledOption;
function skipDisabledOptions(currentIndex, key, items) {
    var newIndex = currentIndex;
    while (isDisabledOption(newIndex, items)) {
        newIndex += key === 'ArrowUp' ? -1 : 1;
    }
    return newIndex;
}
exports.skipDisabledOptions = skipDisabledOptions;
function getUpdatedActiveIndex(currentIndex, key, items) {
    var newIndex = currentIndex;
    // Increment or decrement index based on user keystroke.
    newIndex += key === 'ArrowUp' ? -1 : 1;
    // Skip over any disabled options.
    newIndex = skipDisabledOptions(newIndex, key, items);
    // If we've reached the end, go back to the beginning or vice-versa.
    if (newIndex === items.length) {
        newIndex = -1;
    }
    else if (newIndex === -2) {
        newIndex = items.length - 1;
        // Skip over any disabled options.
        newIndex = skipDisabledOptions(newIndex, key, items);
    }
    return newIndex;
}
exports.default = getUpdatedActiveIndex;
