"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueId = exports.pick = exports.noop = exports.isString = exports.isFunction = void 0;
var idCounter = 0;
// eslint-disable-next-line @typescript-eslint/ban-types
function isFunction(value) {
    return typeof value === 'function';
}
exports.isFunction = isFunction;
function isString(value) {
    return typeof value === 'string';
}
exports.isString = isString;
// eslint-disable-next-line @typescript-eslint/no-empty-function
function noop() { }
exports.noop = noop;
function pick(obj, keys) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    var result = {};
    keys.forEach(function (key) {
        result[key] = obj[key];
    });
    return result;
}
exports.pick = pick;
function uniqueId(prefix) {
    idCounter += 1;
    return (prefix == null ? '' : String(prefix)) + idCounter;
}
exports.uniqueId = uniqueId;
