"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var warn_1 = __importDefault(require("./warn"));
function validateSelectedPropChange(prevSelected, selected) {
    var uncontrolledToControlled = !prevSelected && selected;
    var controlledToUncontrolled = prevSelected && !selected;
    var from, to, precedent;
    if (uncontrolledToControlled) {
        from = 'uncontrolled';
        to = 'controlled';
        precedent = 'an';
    }
    else {
        from = 'controlled';
        to = 'uncontrolled';
        precedent = 'a';
    }
    var message = "You are changing " + precedent + " " + from + " typeahead to be " + to + ". " +
        ("Input elements should not switch from " + from + " to " + to + " (or vice versa). ") +
        'Decide between using a controlled or uncontrolled element for the ' +
        'lifetime of the component.';
    warn_1.default(!(uncontrolledToControlled || controlledToUncontrolled), message);
}
exports.default = validateSelectedPropChange;
